Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmort.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmort.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmort.F90	(revision 6534)
@@ -33,4 +33,7 @@
    REAL(wp), PUBLIC :: mprat   !:
    REAL(wp), PUBLIC :: mprat2  !:
+#if defined key_c13
+   REAL(wp), PUBLIC :: e13c_cal !:
+#endif
 
 
@@ -121,4 +124,20 @@
                tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - 2. * zprcaca
                tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) + zprcaca
+#if defined key_n15
+               tra(ji,jj,jk,jp15phy) = tra(ji,jj,jk,jp15phy) - zmortp   &
+                                                  * ( trb(ji,jj,jk,jp15phy) / (trb(ji,jj,jk,jpphy) + rtrn ) )
+#endif
+
+#if defined key_c13
+               tra(ji,jj,jk,jp13phy) = tra(ji,jj,jk,jp13phy) - zmortp   &
+                                                  * ( trb(ji,jj,jk,jp13phy) / (trb(ji,jj,jk,jpphy) + rtrn ) )
+
+               tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) - zprcaca *  ( 1. - e13c_cal/1000. ) &
+                                                  * ( trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) ) 
+               tra(ji,jj,jk,jp13cal) = tra(ji,jj,jk,jp13cal) + zprcaca *  ( 1. - e13c_cal/1000. ) &
+                                                  * ( trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) )
+#endif
+
+               !
 #if defined key_kriest
                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zmortp
@@ -130,4 +149,18 @@
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ( 1. - zfracal ) * zmortp * zfactfe
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zfracal * zmortp * zfactfe
+#if defined key_n15
+               tra(ji,jj,jk,jp15goc) = tra(ji,jj,jk,jp15goc) + zfracal * zmortp & 
+                                                  * ( trb(ji,jj,jk,jp15phy) / (trb(ji,jj,jk,jpphy) + rtrn ) )
+               tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) + ( 1. - zfracal ) * zmortp &
+                                                  * ( trb(ji,jj,jk,jp15phy) / (trb(ji,jj,jk,jpphy) + rtrn ) )
+#endif
+
+#if defined key_c13
+               tra(ji,jj,jk,jp13goc) = tra(ji,jj,jk,jp13goc) + zfracal * zmortp &
+                                                  * ( trb(ji,jj,jk,jp13phy) / (trb(ji,jj,jk,jpphy) + rtrn ) )
+               tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) + ( 1. - zfracal ) * zmortp &
+                                                  * ( trb(ji,jj,jk,jp13phy) / (trb(ji,jj,jk,jpphy) + rtrn ) )
+#endif
+
 #endif
             END DO
@@ -204,4 +237,14 @@
                tra(ji,jj,jk,jpdsi) = tra(ji,jj,jk,jpdsi) - zmortp2 * zfactsi
                tra(ji,jj,jk,jpgsi) = tra(ji,jj,jk,jpgsi) + zmortp2 * zfactsi
+#if defined key_n15
+               tra(ji,jj,jk,jp15dia) = tra(ji,jj,jk,jp15dia) - zmortp2 & 
+                                                  * ( trb(ji,jj,jk,jp15dia) / (trb(ji,jj,jk,jpdia) + rtrn ) )
+#endif
+#if defined key_c13
+               tra(ji,jj,jk,jp13dia) = tra(ji,jj,jk,jp13dia) - zmortp2 &
+                                                  * ( trb(ji,jj,jk,jp13dia) / (trb(ji,jj,jk,jpdia) + rtrn ) )
+#endif
+
+
 #if defined key_kriest
                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zmortp2  
@@ -213,4 +256,18 @@
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + 0.5 * ztortp2 * zfactfe
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + ( zrespp2 + 0.5 * ztortp2 ) * zfactfe
+#if defined key_n15
+               tra(ji,jj,jk,jp15goc) = tra(ji,jj,jk,jp15goc) + ( zrespp2 + 0.5 * ztortp2 ) &
+                                                  * ( trb(ji,jj,jk,jp15dia) / (trb(ji,jj,jk,jpdia) + rtrn ) )
+               tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) + 0.5 * ztortp2 &
+                                                  * ( trb(ji,jj,jk,jp15dia) / (trb(ji,jj,jk,jpdia) + rtrn ) )
+#endif
+
+#if defined key_n15
+               tra(ji,jj,jk,jp13goc) = tra(ji,jj,jk,jp13goc) + ( zrespp2 + 0.5 * ztortp2 ) &
+                                                  * ( trb(ji,jj,jk,jp13dia) / (trb(ji,jj,jk,jpdia) + rtrn ) )
+               tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) + 0.5 * ztortp2 &
+                                                  * ( trb(ji,jj,jk,jp13dia) / (trb(ji,jj,jk,jpdia) + rtrn ) )
+#endif
+
 #endif
             END DO
@@ -242,5 +299,9 @@
       !!----------------------------------------------------------------------
 
-      NAMELIST/nampismort/ wchl, wchld, wchldm, mprat, mprat2
+      NAMELIST/nampismort/ wchl, wchld, wchldm, mprat, &
+#ifdef key_c13
+                &     e13c_cal,                        &
+#endif
+                &     mprat2
       INTEGER :: ios                 ! Local integer output status for namelist read
 
@@ -263,4 +324,7 @@
          WRITE(numout,*) '    phytoplankton mortality rate              mprat     =', mprat
          WRITE(numout,*) '    Diatoms mortality rate                    mprat2    =', mprat2
+#ifdef key_c13
+          WRITE(numout,*) '    C13 Calcification Fractionation          e13c_cal  =', e13c_cal
+#endif
       ENDIF
 
@@ -277,3 +341,3 @@
 
    !!======================================================================
-END MODULE p4zmort
+END MODULE  p4zmort
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90	(revision 6534)
@@ -45,4 +45,11 @@
    REAL(wp), PUBLIC ::  fecdm           !:
    REAL(wp), PUBLIC ::  grosip          !:
+#if defined key_n15
+   REAL(wp), PUBLIC ::  e15n_prod       !:
+#endif
+#if defined key_c13
+   REAL(wp), PUBLIC ::  e13c_min       !:
+   REAL(wp), PUBLIC ::  e13c_max      !:
+#endif
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prmax    !: optimal production = f(temperature)
@@ -76,8 +83,15 @@
       INTEGER, INTENT(in) :: kt, knt
       !
-      INTEGER  ::   ji, jj, jk
+      INTEGER  ::   ji, jj, jk, jm
       REAL(wp) ::   zsilfac, znanotot, zdiattot, zconctemp, zconctemp2
       REAL(wp) ::   zratio, zmax, zsilim, ztn, zadap
       REAL(wp) ::   zlim, zsilfac2, zsiborn, zprod, zproreg, zproreg2
+#ifdef key_n15
+      REAL(wp) ::   zr15_reg, zr15_new, zu_15, zun_15
+#endif
+#ifdef key_c13
+      REAL(wp) ::   zr13, zr13_2, z_e13c_prod, z_e13c_prod2
+      REAL(wp) ::   ztc, zft, zrhop, zfco3, zbot, zdic, zph, zalka, zalk, zah2
+#endif
       REAL(wp) ::   zmxltst, zmxlday, zmaxday
       REAL(wp) ::   zpislopen  , zpislope2n
@@ -88,4 +102,7 @@
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zpislopead, zpislopead2, zprdia, zprbio, zprdch, zprnch, zysopt, zw3d   
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zprorca, zprorcad, zprofed, zprofen, zprochln, zprochld, zpronew, zpronewd
+#ifdef key_c13
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: za_g, za_dic, zh2co3, z_co3
+#endif
       !!---------------------------------------------------------------------
       !
@@ -96,4 +113,7 @@
       CALL wrk_alloc( jpi, jpj, jpk, zpislopead, zpislopead2, zprdia, zprbio, zprdch, zprnch, zysopt            ) 
       CALL wrk_alloc( jpi, jpj, jpk, zprorca, zprorcad, zprofed, zprofen, zprochln, zprochld, zpronew, zpronewd )
+#ifdef key_c13
+      CALL wrk_alloc( jpi, jpj, jpk, za_g, za_dic, zh2co3, z_co3)
+#endif
       !
       zprorca (:,:,:) = 0._wp
@@ -294,4 +314,60 @@
          END DO
       END DO
+
+      ! Computation of the C13 fractionation factor from Laws et al. 1995
+#if defined key_c13
+      DO jm = 1, 10
+!CDIR NOVERRCHK
+         DO jk = 1, jpkm1
+!CDIR NOVERRCHK
+           DO jj = 1, jpj
+!CDIR NOVERRCHK
+             DO ji = 1, jpi
+
+               ! DUMMY VARIABLES FOR DIC, H+, AND BORATE
+               zbot  = borat(ji,jj,jk)
+               zrhop = rhop(ji,jj,jk) / 1000. + rtrn
+               zdic  = trb(ji,jj,jk,jpdic) / zrhop
+               zph   = MAX( hi(ji,jj,jk), 1.e-10 ) / zrhop
+               zalka = trb(ji,jj,jk,jptal) / zrhop
+
+               ! CALCULATE [ALK]([CO3--], [HCO3-])
+               zalk  = zalka - (  akw3(ji,jj,jk) / zph - zph + zbot / ( 1.+ zph / akb3(ji,jj,jk) )  )
+
+               ! CALCULATE [H+] AND [H2CO3]
+               zah2   = SQRT(  (zdic-zalk)**2 + 4.* ( zalk * ak23(ji,jj,jk)   &
+                  &                               / ak13(ji,jj,jk) ) * ( 2.* zdic - zalk )  )
+               zah2   = 0.5 * ak13(ji,jj,jk) / zalk * ( ( zdic - zalk ) + zah2 )
+               zh2co3(ji,jj,jk) = ( 2.* zdic - zalk ) / ( 2.+ ak13(ji,jj,jk) / zah2) * zrhop
+               z_co3(ji,jj,jk) = zalk / ( 2. + zah2 / ak23(ji,jj,jk) ) * zrhop
+               hi(ji,jj,jk)   = zah2 * zrhop
+             END DO
+           END DO
+         END DO
+      END DO
+
+!CDIR NOVERRCHK
+         DO jk = 1, jpkm1
+!CDIR NOVERRCHK
+           DO jj = 1, jpj
+!CDIR NOVERRCHK
+             DO ji = 1, jpi
+
+
+!           ! Compute fractionation factors for C13 from Zhang et al. 1995
+
+               zfco3 = MAX(0.05,(z_co3(ji,jj,jk)/trb(ji,jj,jk,jpdic)+rtrn))
+               zfco3 = MIN(0.2 , zfco3)
+               ztc = MIN( 35., tsn(ji,jj,jk,jp_tem) )
+               zft = MIN(25.,ztc)
+               zft = MAX( 5.,zft)
+               za_g(ji,jj,jk) = 1.   + ( -0.0049 * zft - 1.31 ) / 1000.
+               za_dic(ji,jj,jk) = 1. + ( 0.014 * zft * zfco3 &
+                   - 0.105 * zft + 10.53 ) / 1000.
+            END DO
+         END DO
+      END DO
+
+#endif
 
       ! Computation of the various production terms 
@@ -390,4 +466,34 @@
               zproreg  = zprorca(ji,jj,jk) - zpronew(ji,jj,jk)
               zproreg2 = zprorcad(ji,jj,jk) - zpronewd(ji,jj,jk)
+#ifdef key_n15
+              zu_15 = MIN(1.,MAX(0., 1. - (zpronew(ji,jj,jk)+zpronewd(ji,jj,jk))/(rtrn + trb(ji,jj,jk,jp15no3))))
+              zun_15 = MIN(1.,MAX(0., 1. - (zproreg+zproreg2) / (rtrn + trb(ji,jj,jk,jp15nh4))))
+
+              zr15_new = ( 1. - e15n_prod/1000. * zu_15) * trb(ji,jj,jk,jp15no3) / (trb(ji,jj,jk,jpno3) + rtrn)
+              zr15_reg = ( 1. - e15n_prod/1000. * zun_15) * trb(ji,jj,jk,jp15nh4) / (trb(ji,jj,jk,jpnh4) + rtrn)
+#endif
+
+#ifdef key_c13
+
+              z_e13c_prod  = MAX(e13c_min,MIN(e13c_max,( (86400 * zprorca(ji,jj,jk) / (rtrn + trb(ji,jj,jk,jpphy) ) &
+              &                               / ( rfact2 * (zh2co3(ji,jj,jk)/1025*1.e9 + rtrn)  ) - 0.371 ) / (-0.015))))
+              
+              z_e13c_prod2 = MAX(e13c_min,MIN(e13c_max,( ( 86400 * zprorcad(ji,jj,jk) / (rtrn + trb(ji,jj,jk,jpdia) ) &
+              &                               / ( rfact2 * (zh2co3(ji,jj,jk)/1025*1.e9 + rtrn)  ) - 0.371 ) / (-0.015))))
+
+              !
+              if ((mig(ji).eq.74).and.(mig(jj).eq.74).and.(jk.eq.1)) THEN
+                      write(numout,*) z_e13c_prod, 86400*(zprorca(ji,jj,jk)/(rtrn + trb(ji,jj,jk,jpphy))/rfact2) , (zh2co3(ji,jj,jk)) , &
+               &                      ((86400 * zprorca(ji,jj,jk) / (rtrn + trb(ji,jj,jk,jpphy) ) &
+               &                             / ( rfact2 * (zh2co3(ji,jj,jk)/1025*1.e9 + rtrn)  ) - 0.371 ) / (-0.015))
+              endif
+
+
+              zr13 = ( 1. - z_e13c_prod/1000. ) * trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn )  !&
+              !&                                 * za_g(ji,jj,jk) / (za_dic(ji,jj,jk) + rtrn)
+              zr13_2 = ( 1. - z_e13c_prod2/1000. ) * trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) !&
+              !&                                 * za_g(ji,jj,jk) / (za_dic(ji,jj,jk) + rtrn)
+#endif
+
               tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) - zprorca(ji,jj,jk) - zprorcad(ji,jj,jk)
               tra(ji,jj,jk,jpno3) = tra(ji,jj,jk,jpno3) - zpronew(ji,jj,jk) - zpronewd(ji,jj,jk)
@@ -408,4 +514,25 @@
               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) + rno3 * ( zpronew(ji,jj,jk) + zpronewd(ji,jj,jk) ) &
                  &                                      - rno3 * ( zproreg + zproreg2 )
+#ifdef key_n15
+
+              tra(ji,jj,jk,jp15no3) = tra(ji,jj,jk,jp15no3) - zr15_new * ( zpronew(ji,jj,jk) + zpronewd(ji,jj,jk) )
+              tra(ji,jj,jk,jp15nh4) = tra(ji,jj,jk,jp15nh4) - zr15_reg * ( zproreg + zproreg2 )
+              tra(ji,jj,jk,jp15phy) = tra(ji,jj,jk,jp15phy) + zr15_new * zpronew(ji,jj,jk) * texcret  &
+                                                            + zr15_reg * zproreg * texcret    
+              tra(ji,jj,jk,jp15dia) = tra(ji,jj,jk,jp15dia) + zr15_new * zpronewd(ji,jj,jk) * texcret2  &
+                                                            + zr15_reg * zproreg2 * texcret2 
+              tra(ji,jj,jk,jp15doc) = tra(ji,jj,jk,jp15doc) + zr15_new * zpronew(ji,jj,jk) * excret     &
+                                                            + zr15_reg * zproreg * excret     &
+                                                            + zr15_new * zpronewd(ji,jj,jk) * excret2   &
+                                                            + zr15_reg * zproreg2 * excret2
+#endif
+
+#ifdef key_c13
+              tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) - zr13 * zprorca(ji,jj,jk) - zr13_2 * zprorcad(ji,jj,jk) 
+              tra(ji,jj,jk,jp13phy) = tra(ji,jj,jk,jp13phy) + zr13 * zprorca(ji,jj,jk) * texcret  
+              tra(ji,jj,jk,jp13dia) = tra(ji,jj,jk,jp13dia) + zr13_2 * zprorcad(ji,jj,jk) * texcret2 
+              tra(ji,jj,jk,jp13doc) = tra(ji,jj,jk,jp13doc) + zr13 * zprorca(ji,jj,jk) * excret       &   
+                                                            + zr13_2 * zprorcad(ji,jj,jk) * excret2
+#endif
           END DO
         END DO
@@ -548,4 +675,7 @@
      CALL wrk_dealloc( jpi, jpj, jpk, zpislopead, zpislopead2, zprdia, zprbio, zprdch, zprnch, zysopt            ) 
      CALL wrk_dealloc( jpi, jpj, jpk, zprorca, zprorcad, zprofed, zprofen, zprochln, zprochld, zpronew, zpronewd )
+#ifdef key_c13
+     CALL wrk_dealloc( jpi, jpj, jpk, za_g, za_dic, zh2co3, z_co3)
+#endif
      !
      IF( nn_timing == 1 )  CALL timing_stop('p4z_prod')
@@ -567,5 +697,13 @@
       !
       NAMELIST/nampisprod/ pislope, pislope2, xadap, ln_newprod, bresp, excret, excret2,  &
+#if defined key_n15
+         &                 e15n_prod, &
+#endif
+#if defined key_c13
+         &                 e13c_min, e13c_max, &
+#endif
+
          &                 chlcnm, chlcdm, chlcmin, fecnm, fecdm, grosip
+
       INTEGER :: ios                 ! Local integer output status for namelist read
       !!----------------------------------------------------------------------
@@ -599,4 +737,12 @@
          WRITE(numout,*) '    Maximum Fe/C in nanophytoplankton         fecnm        =', fecnm
          WRITE(numout,*) '    Minimum Fe/C in diatoms                   fecdm        =', fecdm
+#if defined key_n15
+         WRITE(numout,*) '    N15 assimilation fractionation            e15n_prod    =', e15n_prod
+#endif
+#if defined key_c13
+         WRITE(numout,*) '    C13 assimilation fractionation min       e13c_min    =', e13c_min
+         WRITE(numout,*) '    C13 assimilation fractionation max       e13c_max   =', e13c_max
+#endif
+
       ENDIF
       !
@@ -629,3 +775,3 @@
 
    !!======================================================================
-END MODULE p4zprod
+END MODULE  p4zprod
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zrem.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zrem.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zrem.F90	(revision 6534)
@@ -45,5 +45,8 @@
    REAL(wp), PUBLIC ::  xsilab     !: fraction of labile biogenic silica 
    REAL(wp), PUBLIC ::  oxymin     !: halk saturation constant for anoxia 
-
+#if defined key_n15
+   REAL(wp), PUBLIC ::  e15n_denit !: N15 denitrification fractionation 
+   REAL(wp), PUBLIC ::  e15n_nit !: N15 nitrification fractionation 
+#endif
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   denitr     !: denitrification array
@@ -141,8 +144,8 @@
                ! -----------------------------------------------------
                zolimit = zremik * ( 1.- nitrfac(ji,jj,jk) ) * trb(ji,jj,jk,jpdoc) 
-               zolimi(ji,jj,jk) = MIN( ( trb(ji,jj,jk,jpoxy) - rtrn ) / o2ut, zolimit ) 
+               zolimi(ji,jj,jk) = MIN( ( trb(ji,jj,jk,jpoxy) - 1.E-8 ) / o2ut, zolimit ) 
                ! Ammonification in suboxic waters with denitrification
                ! -------------------------------------------------------
-               denitr(ji,jj,jk)  = MIN(  ( trb(ji,jj,jk,jpno3) - rtrn ) / rdenit,   &
+               denitr(ji,jj,jk)  = MIN(  ( trb(ji,jj,jk,jpno3) - 1.E-8 ) / rdenit,   &
                   &                     zremik * nitrfac(ji,jj,jk) * trb(ji,jj,jk,jpdoc)  )
                !
@@ -169,8 +172,19 @@
                ! Update of the tracers trends
                ! ----------------------------
+               denitnh4(ji,jj,jk)  = MIN(  ( trb(ji,jj,jk,jpno3) - 1.E-8 ) / rdenita,   &
+                  &                     denitnh4(ji,jj,jk)  )
+               denitnh4(ji,jj,jk) = MAX(0., denitnh4(ji,jj,jk) )
+
                tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) - zonitr - denitnh4(ji,jj,jk)
                tra(ji,jj,jk,jpno3) = tra(ji,jj,jk,jpno3) + zonitr - rdenita * denitnh4(ji,jj,jk)
                tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2nit * zonitr
                tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - 2 * rno3 * zonitr + rno3 * ( rdenita - 1. ) * denitnh4(ji,jj,jk)
+# if defined key_n15
+               tra(ji,jj,jk,jp15nh4) = tra(ji,jj,jk,jp15nh4) - ( zonitr * (1. - e15n_nit / 1000.) + denitnh4(ji,jj,jk) ) &
+                                 &     *   trb(ji,jj,jk,jp15nh4) / (trb(ji,jj,jk,jpnh4) + rtrn )
+               tra(ji,jj,jk,jp15no3) = tra(ji,jj,jk,jp15no3) + zonitr * (1. - e15n_nit / 1000.) &  
+                                 &     *  trb(ji,jj,jk,jp15nh4) / (trb(ji,jj,jk,jpnh4) + rtrn )  &
+                                 &    - rdenita * denitnh4(ji,jj,jk) *   trb(ji,jj,jk,jp15no3) / (trb(ji,jj,jk,jpno3) + rtrn )
+# endif
             END DO
          END DO
@@ -242,4 +256,11 @@
                tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zorem
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zofer
+#if defined key_n15
+               tra(ji,jj,jk,jp15doc) = tra(ji,jj,jk,jp15doc) + zorem * trb(ji,jj,jk,jp15poc) / (trb(ji,jj,jk,jppoc) + rtrn )
+#endif
+#if defined key_c13
+               tra(ji,jj,jk,jp13doc) = tra(ji,jj,jk,jp13doc) + zorem * trb(ji,jj,jk,jp13poc) / (trb(ji,jj,jk,jppoc) + rtrn )
+#endif
+
 #if defined key_kriest
                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zorem
@@ -247,8 +268,18 @@
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zofer
 #else
-               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zorem2 - zorem
-               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) - zorem2
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zorem2 - zorem 
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) - zorem2 
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zofer2 - zofer
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) - zofer2
+#if defined key_n15
+               tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) + zorem2 * trb(ji,jj,jk,jp15goc) / (trb(ji,jj,jk,jpgoc) + rtrn ) &
+                                      - zorem * trb(ji,jj,jk,jp15poc) / (trb(ji,jj,jk,jppoc) + rtrn )
+               tra(ji,jj,jk,jp15goc) = tra(ji,jj,jk,jp15goc) - zorem2 * trb(ji,jj,jk,jp15goc) / (trb(ji,jj,jk,jpgoc) + rtrn )
+#endif
+#if defined key_c13
+               tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) + zorem2 * trb(ji,jj,jk,jp13goc) / (trb(ji,jj,jk,jpgoc) + rtrn ) &
+                                      - zorem * trb(ji,jj,jk,jp13poc) / (trb(ji,jj,jk,jppoc) + rtrn )
+               tra(ji,jj,jk,jp13goc) = tra(ji,jj,jk,jp13goc) - zorem2 * trb(ji,jj,jk,jp13goc) / (trb(ji,jj,jk,jpgoc) + rtrn )
+#endif
 #endif
 
@@ -313,4 +344,19 @@
          tra(:,:,jk,jpdic) = tra(:,:,jk,jpdic) + zolimi (:,:,jk) + denitr(:,:,jk)
          tra(:,:,jk,jptal) = tra(:,:,jk,jptal) + rno3 * ( zolimi(:,:,jk) + ( rdenit + 1.) * denitr(:,:,jk) )
+#if defined key_n15
+         tra(:,:,jk,jp15nh4) = tra(:,:,jk,jp15nh4) + ( zolimi (:,:,jk) + denitr(:,:,jk) ) &
+                                                   * trb(:,:,jk,jp15doc) / ( trb(:,:,jk,jpdoc) + rtrn )
+         tra(:,:,jk,jp15no3) = tra(:,:,jk,jp15no3) - (1. - e15n_denit / 1000.) * denitr (:,:,jk) * rdenit &
+                                                   * trb(:,:,jk,jp15no3) / ( trb(:,:,jk,jpno3) + rtrn )
+         tra(:,:,jk,jp15doc) = tra(:,:,jk,jp15doc) - ( zolimi (:,:,jk) + denitr(:,:,jk) ) &
+                                                   * trb(:,:,jk,jp15doc) / ( trb(:,:,jk,jpdoc) + rtrn )
+#endif
+#if defined key_c13
+         tra(:,:,jk,jp13dic) = tra(:,:,jk,jp13dic) + ( zolimi (:,:,jk) + denitr(:,:,jk) ) &
+                                                   * trb(:,:,jk,jp13doc) / ( trb(:,:,jk,jpdoc) + rtrn )
+         tra(:,:,jk,jp13doc) = tra(:,:,jk,jp13doc) - ( zolimi (:,:,jk) + denitr(:,:,jk) ) &
+                                                   * trb(:,:,jk,jp13doc) / ( trb(:,:,jk,jpdoc) + rtrn )
+#endif
+
       END DO
 
@@ -357,6 +403,11 @@
       !!
       !!----------------------------------------------------------------------
+#if ! defined key_n15
       NAMELIST/nampisrem/ xremik, xremip, nitrif, xsirem, xsiremlab, xsilab,   &
       &                   oxymin
+#else
+      NAMELIST/nampisrem/ xremik, xremip, nitrif, xsirem, xsiremlab, xsilab,   &
+      &                   oxymin, e15n_denit, e15n_nit
+#endif
       INTEGER :: ios                 ! Local integer output status for namelist read
 
@@ -381,4 +432,8 @@
          WRITE(numout,*) '    NH4 nitrification rate                    nitrif    =', nitrif
          WRITE(numout,*) '    halk saturation constant for anoxia       oxymin    =', oxymin
+#if defined key_n15
+         WRITE(numout,*) '    N15 denitrification fractionation        e15n_denit =', e15n_denit
+         WRITE(numout,*) '    N15 nitrification fractionation          e15n_nit =', e15n_nit
+#endif
       ENDIF
       !
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsbc.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsbc.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsbc.F90	(revision 6534)
@@ -42,4 +42,15 @@
    REAL(wp), PUBLIC  :: concfediaz  !: Fe half-saturation Cste for diazotrophs 
    REAL(wp)          :: hratio      !: Fe:3He ratio assumed for vent iron supply
+#ifdef key_n15
+   REAL(wp), PUBLIC  :: e15n_bdenit  !: N15 Benthic denit fractionation
+   REAL(wp), PUBLIC  :: d15n_nfix    !: dN15 Nfix
+   REAL(wp), PUBLIC  :: d15n_river   !: dN15 river input
+   REAL(wp), PUBLIC  :: d15n_depo    !: dN15 depo
+#endif
+#ifdef key_c13
+   REAL(wp), PUBLIC  :: d13c_rivdoc   !: dC13 river doc input
+   REAL(wp), PUBLIC  :: d13c_rivdic   !: dC13 river dic input
+#endif
+
 
    LOGICAL , PUBLIC  :: ll_sbc
@@ -204,9 +215,16 @@
       TYPE(FLD_N) ::   sn_riverdoc, sn_riverdic, sn_riverdsi   ! informations about the fields to be read
       TYPE(FLD_N) ::   sn_riverdin, sn_riverdon, sn_riverdip, sn_riverdop
-      !
+      
       NAMELIST/nampissbc/cn_dir, sn_dust, sn_solub, sn_riverdic, sn_riverdoc, sn_riverdin, sn_riverdon,     &
         &                sn_riverdip, sn_riverdop, sn_riverdsi, sn_ndepo, sn_ironsed, sn_hydrofe, &
         &                ln_dust, ln_solub, ln_river, ln_ndepo, ln_ironsed, ln_ironice, ln_hydrofe,    &
+#ifdef key_n15
+        &                e15n_bdenit, d15n_nfix, d15n_river, d15n_depo,   &
+#endif
+#ifdef key_c13
+        &                d13c_rivdic, d13c_rivdoc,     &
+#endif
         &                sedfeinput, dustsolub, icefeinput, wdust, mfrac, nitrfix, diazolight, concfediaz, hratio
+
       !!----------------------------------------------------------------------
       !
@@ -252,4 +270,14 @@
          WRITE(numout,*) '    fe half-saturation cste for diazotrophs  concfediaz  = ', concfediaz
          WRITE(numout,*) '    Fe to 3He ratio assumed for vent iron supply hratio  = ', hratio
+#ifdef key_n15
+         WRITE(numout,*) '    N15 Benthic denit fractionation          e15n_bdenit = ', e15n_bdenit
+         WRITE(numout,*) '    dN15 nfix                                d15n_nfix   = ', d15n_nfix
+         WRITE(numout,*) '    dN15 river input                         d15n_river  = ', d15n_river
+         WRITE(numout,*) '    dN15 depo                                d15n_depo   = ', d15n_depo
+#endif
+#ifdef key_c13
+         WRITE(numout,*) '    dC13 river dic input                     d13c_rivdic = ', d13c_rivdic
+         WRITE(numout,*) '    dC13 river doc input                     d13c_rivdoc = ', d13c_rivdoc
+#endif
       END IF
 
@@ -519,3 +547,3 @@
 
    !!======================================================================
-END MODULE p4zsbc
+END MODULE  p4zsbc
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90	(revision 6534)
@@ -69,4 +69,6 @@
       REAL(wp) ::  zsiloss, zcaloss, zws3, zws4, zwsc, zdep, zwstpoc
       REAL(wp) ::  ztrfer, ztrpo4, zwdust, zlight
+      REAL(wp) :: zwstpoc15, zwstpoc13
+
       !
       CHARACTER (len=25) :: charout
@@ -175,4 +177,11 @@
                   tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) +  rivdic(ji,jj) * rfact2
                   tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) +  ( rivalk(ji,jj) - rno3 * rivdin(ji,jj) ) * rfact2
+#if defined key_n15
+                  tra(ji,jj,jk,jp15no3) = tra(ji,jj,jk,jp15no3) + ( 1. + d15n_river / 1000. ) * rivdin(ji,jj) * rfact2
+#endif
+#if defined key_c13
+                  tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) + ( 1. + d13c_rivdic / 1000. ) * rivdic(ji,jj) * rfact2
+#endif
+
                ENDDO
             ENDDO
@@ -185,4 +194,7 @@
          tra(:,:,1,jpno3) = tra(:,:,1,jpno3) + nitdep(:,:) * rfact2
          tra(:,:,1,jptal) = tra(:,:,1,jptal) - rno3 * nitdep(:,:) * rfact2
+#if defined key_n15
+         tra(:,:,1,jp15no3) = tra(:,:,1,jp15no3) + (1. + d15n_depo / 1000.) * nitdep(:,:) * rfact2
+#endif
       ENDIF
 
@@ -305,4 +317,11 @@
             zsedcal(ji,jj) = (1.0 - zrivalk) * zcaloss / zdep
             zsedsi (ji,jj) = (1.0 - zrivsil) * zsiloss / zdep
+#if defined key_c13
+            tra(ji,jj,ikt,jp13dic) =  tra(ji,jj,ikt,jp13dic) + zcaloss * zrivalk &
+              &                     * trb(ji,jj,ikt,jp13cal) / ( trb(ji,jj,ikt,jpcal) + rtrn)
+            tra(ji,jj,ikt,jp13cal) =  tra(ji,jj,ikt,jp13cal) - zcaloss * trb(ji,jj,ikt,jp13cal) &
+              &                     / ( trb(ji,jj,ikt,jpcal) + rtrn)
+#endif
+
 #endif
          END DO
@@ -322,4 +341,15 @@
             tra(ji,jj,ikt,jpsfe) = tra(ji,jj,ikt,jpsfe) - trb(ji,jj,ikt,jpsfe) * zws3
             zwstpoc              = trb(ji,jj,ikt,jpgoc) * zws4 + trb(ji,jj,ikt,jppoc) * zws3
+#if defined key_n15
+            tra(ji,jj,ikt,jp15goc) = tra(ji,jj,ikt,jp15goc) - trb(ji,jj,ikt,jp15goc) * zws4
+            tra(ji,jj,ikt,jp15poc) = tra(ji,jj,ikt,jp15poc) - trb(ji,jj,ikt,jp15poc) * zws3
+            zwstpoc15              = trb(ji,jj,ikt,jp15goc) * zws4 + trb(ji,jj,ikt,jp15poc) * zws3
+#endif
+#if defined key_c13
+            tra(ji,jj,ikt,jp13goc) = tra(ji,jj,ikt,jp13goc) - trb(ji,jj,ikt,jp13goc) * zws4
+            tra(ji,jj,ikt,jp13poc) = tra(ji,jj,ikt,jp13poc) - trb(ji,jj,ikt,jp13poc) * zws3
+            zwstpoc13              = trb(ji,jj,ikt,jp13goc) * zws4 + trb(ji,jj,ikt,jp13poc) * zws3
+#endif
+
 # else
             tra(ji,jj,ikt,jpnum) = tra(ji,jj,ikt,jpnum) - trb(ji,jj,ikt,jpnum) * zws4 
@@ -345,4 +375,20 @@
             sdenit(ji,jj) = rdenit * zpdenit / zdep
             zsedc(ji,jj)   = (1. - zrivno3) * zwstpoc / zdep
+#if defined key_n15
+            tra(ji,jj,ikt,jp15doc) = tra(ji,jj,ikt,jp15doc) + zwstpoc15 * zrivno3  &
+                                   - zolimit * zwstpoc15 / ( zwstpoc + rtrn ) &
+                          &        - (zpdenit + zdenitt) * zwstpoc15 / ( zwstpoc + rtrn )
+            tra(ji,jj,ikt,jp15nh4) = tra(ji,jj,ikt,jp15nh4) + zolimit * zwstpoc15 / ( zwstpoc + rtrn ) &
+                          &        + (zpdenit + zdenitt) * zwstpoc15 / ( zwstpoc + rtrn )
+            tra(ji,jj,ikt,jp15no3) = tra(ji,jj,ikt,jp15no3) - (1. - e15n_bdenit / 1000.) * rdenit * (zpdenit + zdenitt) & 
+                          &        * trb(ji,jj,ikt,jp15no3) / ( trb(ji,jj,ikt,jpno3) + rtrn )
+#endif
+#if defined key_c13
+            tra(ji,jj,ikt,jp13doc) = tra(ji,jj,ikt,jp13doc) + zwstpoc13 * zrivno3  &
+                                   - zolimit * zwstpoc13 / ( zwstpoc + rtrn ) &
+                          &        - (zpdenit + zdenitt) * zwstpoc13 / ( zwstpoc + rtrn )
+            tra(ji,jj,ikt,jp13dic) = tra(ji,jj,ikt,jp13dic) + zolimit * zwstpoc13 / ( zwstpoc + rtrn ) &
+                          &        + (zpdenit + zdenitt) * zwstpoc13 / ( zwstpoc + rtrn )
+#endif
 #endif
          END DO
@@ -385,4 +431,7 @@
                &                     * 0.002 * trb(ji,jj,jk,jpdoc) * xstep
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + 0.002 * 4E-10 * zsoufer(ji,jj,jk) * xstep
+#if defined key_n15
+               tra(ji,jj,jk,jp15nh4) = tra(ji,jj,jk,jp15nh4) +  (1. + d15n_nfix / 1000.)  * zfact
+#endif
            END DO
          END DO 
